> For the complete documentation index, see [llms.txt](https://docs.whisk.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.whisk.com/api/shopping-lists/update-an-item-in-a-shopping-list.md).

# Update an Item in a Shopping List

## Update Item

<mark style="color:orange;">`PUT`</mark> `https://api.whisk.com/list/v2/{list_id}/item/{item_id}`

You can use the following path parameters and a body parameter to update an item in a shopping list:

#### Path Parameters

| Name     | Type   | Description                                                             |
| -------- | ------ | ----------------------------------------------------------------------- |
| list\_id | string | The unique identifier of the list that contains the item to be updated. |
| item\_id | string | The unique identifier of the item to be updated.                        |

#### Headers

| Name           | Type   | Description                                                                                                                                      |
| -------------- | ------ | ------------------------------------------------------------------------------------------------------------------------------------------------ |
| Authentication | string | Server Token or a User Access token containing `shopping_list:write` scope to authorize the API usage. For more information, see Authentication. |

#### Request Body

| Name | Type   | Description                                                                                            |
| ---- | ------ | ------------------------------------------------------------------------------------------------------ |
| body | object | The body object contains the item's attributes that can be updated. See the Body Object Example below. |

```graphql
{
  "list": {
    "id": "string",
    "name": "string",
    "primary": true
  },
  "content": {
    "items": [
      {
        "id": "string",
        "item": {
          "name": "string",
          "brand": "string",
          "comment": "string",
          "quantity": 0,
          "unit": "string"
        },
        "checked": true,
        "image_url": "string",
        "analysis": {
          "product": {
            "canonical_name": "string",
            "original_name": "string"
          },
          "category": {
            "canonical_name": "string"
          },
          "brand": {
            "canonical_name": "string"
          }
        },
        "recipe": {
          "recipe_id": "string",
          "position": 0
        },
        "combined": {
          "combined_item_id": "string",
          "quantity": 0
        },
        "created_time": "string",
        "updated_at": "string",
        "matching_properties": {
          "gtin": "string",
          "custom_product_id": "string"
        }
      }
    ],
    "combined_items": [
      {
        "id": "string",
        "item": {
          "name": "string",
          "brand": "string",
          "comment": "string",
          "quantity": 0,
          "unit": "string"
        },
        "checked": true,
        "image_url": "string",
        "analysis": {
          "product": {
            "canonical_name": "string",
            "original_name": "string"
          },
          "category": {
            "canonical_name": "string"
          },
          "brand": {
            "canonical_name": "string"
          }
        },
        "created_time": "string",
        "updated_at": "string"
      }
    ],
    "recipes": [
      {
        "id": "string",
        "name": "string",
        "images": [
          {
            "responsive": {
              "url": "string",
              "width": 0,
              "height": 0,
              "selection": {
                "x": 0,
                "y": 0,
                "width": 0,
                "height": 0
              }
            },
            "url": "string"
          }
        ],
        "source": {
          "name": "string",
          "display_name": "string",
          "source_recipe_url": "string",
          "image": {
            "responsive": {
              "url": "string",
              "width": 0,
              "height": 0,
              "selection": {
                "x": 0,
                "y": 0,
                "width": 0,
                "height": 0
              }
            },
            "url": "string"
          },
          "license": "LICENCE_INVALID"
        }
      }
    ]
  }
}
```

```yaml
{
  "error_code": "REAL_CODES_ARE_IN_ENDPOINT_DESCRIPTION",
  "message": "Additional details about error are not static and can be changed"
}
```

{% tab title="401 This failed response appears due to API authentication failure. The possible error codes that may appear are: auth.tokenNotFound , auth.tokenExpired, auth.tokenInvalid, auth.tokenRequired." %}

```yaml
{
  "code": "auth.tokenNotFound"
}
```

```yaml
This is unexpected response, something is wrong on our side, please contact: help@whisk.com
```

### Request Body Object Example

```graphql
{
  "fields": {
    "name": "strawberry ice cream",
    "brand": "magnum",
    "comment": "frozen",
    "quantity": 10,
    "unit": "scoop",
    "checked": true
  },
  "mask": {
    "paths": [
      "name", "brand", "comment", "quantity", "unit", "checked"
    ]
  }
}
```

#### `fields`

The `fields` object allows you to specify new values for following attributes of an item:

| Attribute  | Type    | Description                                        |
| ---------- | ------- | -------------------------------------------------- |
| `name`     | string  | The item's name.                                   |
| `brand`    | array   | The brand name if the item is of a specific brand. |
| `comment`  | boolean | Additional information attached with the item.     |
| `quantity` | number  | The item's volume or count.                        |
| `unit`     | array   | The measurement unit of the item's quantity.       |
| `checked`  | boolean | Check or uncheck the item in the list.             |

#### `mask`

The `mask` object allows you to specify the attributes that you want to update specifically. It is essential to use this object because you need to specify values for all the attributes that the `fields` object contains regardless of whether you want to update all or only a few of them in each update request. Hence, the `mask` object determines which attributes are to be updated exactly.

The `mask` object contains the `path` array that allows you to add a comma-separated list of attributes to update.

### Sample Request and Response

{% tabs %}
{% tab title="Curl Request" %}

```bash
curl -X PUT "https://api.whisk.com/list/v2/106c5fa85ddbba343099347c57e54632500/item/611b542e-4d9f-4a1a-afab-be960c88a3c2"
    -H "Accept: application/json"
    -H "Authorization: Bearer <YOUR-API-ACCESS-KEY>"
    -d "{ \"fields\": { \"name\": \"strawberry ice cream\", \"brand\": \"magnum\", \"comment\": \"frozen\", \"quantity\": 10, \"unit\": \"scoop\", \"checked\": true }, \"mask\": { \"paths\": [ \"name\", \"brand\", \"comment\", \"quantity\", \"unit\", \"checked\" ] }}"
```

{% hint style="info" %}
Whisk allows you to discover and understand its API capabilities on the Swagger interface with the ability to try out the API calls directly in your browser. You can call this endpoint [here](https://api.whisk.com/spec/#/ShoppingListAPI/ShoppingListAPI_UpdateItem).
{% endhint %}
{% endtab %}

{% tab title="Response" %}

```graphql
{
  "list": {
    "id": "106c5fa85ddbba343099347c57e54632500",
    "name": "My New Shopping List"
  },
  "content": {
    "items": [
      {
        "id": "611b542e-4d9f-4a1a-afab-be960c88a3c2",
        "item": {
          "name": "strawberry ice cream",
          "brand": "magnum",
          "comment": "frozen",
          "quantity": 10,
          "unit": "scoop"
        },
        "checked": true,
        "image_url": "https://image-cdn.whisk.com/image/upload/v1579874533/custom_upload/05b8a428286fb4177ae5d82a4d00bc03.jpg",
        "analysis": {
          "product": {
            "canonical_name": "STRAWBERRY ICE CREAM"
          },
          "category": {
            "canonical_name": "FROZEN"
          },
          "brand": {
            "canonical_name": "MAGNUM"
          }
        },
        "created_time": "1614714958",
        "updated_at": "1614715075",
        "matching_properties": {
          "gtin": "00000034411207"
        }
      }
    ]
  }
}
```

{% hint style="info" %}
A successful response returns the shopping list definition with an updated list of items. To understand the data structure of a shopping list definition, see [Shopping List Object](/api/shopping-lists.md#shopping-list-object).
{% endhint %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.whisk.com/api/shopping-lists/update-an-item-in-a-shopping-list.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
